]> git.pld-linux.org Git - packages/apache.git/blobdiff - apache.init
- renumbered patches
[packages/apache.git] / apache.init
index d95d3b82deb98e9b2a1c14e0e4f2f6d35a932fbe..f5e09b930ed196b9eef4a7303d2fa6e0897d902e 100644 (file)
@@ -33,6 +33,14 @@ else
 fi
 
 [ -z "$HTTPD_MPM" ] && HTTPD_MPM="prefork"
+if   [ -d "${HTTPD_CONF:-'/etc/httpd/httpd.conf'}" ]; then
+       CFG="-f ${HTTPD_CONF:-'/etc/httpd/httpd.conf'}"
+elif [ -n "$HTTPD_CONF" ]; then
+       echo "error: HTTPD_CONF='$HTTPD_CONF': not a file, not a directory"
+       exit 1
+else
+       CFG=""
+fi
 
 RETVAL=0
 # See how we were called.
@@ -41,7 +49,7 @@ case "$1" in
        # Check if the service is already running?
        if [ ! -f /var/lock/subsys/httpd ]; then
                msg_starting httpd.${HTTPD_MPM}
-               daemon httpd.${HTTPD_MPM} -f /etc/httpd/httpd.conf $HTTPD_OPTS
+               daemon httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS
                RETVAL=$?
                [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
        else
@@ -52,23 +60,12 @@ case "$1" in
        # Stop daemons.
        if [ -f /var/lock/subsys/httpd ]; then
                msg_stopping httpd.${HTTPD_MPM}
-               if [ -f /var/run/httpd.pid ]; then
-                       PID=`cat /var/run/httpd.pid`
-               else
-                       PID=0
+               daemon --waitforname httpd.${HTTPD_MPM} --waitfortime 60 httpd.${HTTPD_MPM} $CFG -k stop
+               RET=$?
+               # Delete pidfile only when apache was called successfully
+               if [ $RET -eq 0 ]; then
+                       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
                fi
-               daemon httpd.${HTTPD_MPM} -f /etc/httpd/httpd.conf -k stop
-               # Wait for httpd to really stop
-               if [ ! $PID -eq 0 ]; then
-                       show "Waiting for httpd to stop"
-                       busy
-                       while ps -o command $PID | grep -q ^httpd
-                       do
-                               sleep 1
-                       done
-                       ok
-               fi
-               rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
        else
                msg_not_running httpd.${HTTPD_MPM}
        fi
@@ -76,7 +73,7 @@ case "$1" in
   status)
        status httpd.${HTTPD_MPM}
        RETVAL=$?
-       /usr/sbin/httpd.${HTTPD_MPM} -f /etc/httpd/httpd.conf -S
+       /usr/sbin/httpd.${HTTPD_MPM} $CFG -S
        ;;
   restart)
        $0 stop
@@ -85,7 +82,13 @@ case "$1" in
   reload|force-reload|graceful)
        if [ -f /var/lock/subsys/httpd ]; then
                msg_reloading httpd.${HTTPD_MPM}
-               daemon httpd.${HTTPD_MPM} -f /etc/httpd/httpd.conf -k graceful
+               httpd.${HTTPD_MPM} $CFG -t > /dev/null 2>&1
+               if [ $? -eq 0 ]; then
+                   daemon httpd.${HTTPD_MPM} $CFG -k graceful
+               else
+                   fail
+                   echo "Configuration file syntax test failed."
+               fi
                RETVAL=$?
        else
                msg_not_running httpd.${HTTPD_MPM} >&2
This page took 0.034394 seconds and 4 git commands to generate.